org.keycloak.userprofile

## Class DeclarativeUserProfileProvider

- java.lang.Object
- - org.keycloak.userprofile.AbstractUserProfileProvider<UserProfileProvider>
  - - org.keycloak.userprofile.DeclarativeUserProfileProvider

- All Implemented Interfaces:
    AmphibianProviderFactory<UserProfileProvider>, ComponentFactory<UserProfileProvider,UserProfileProvider>, ConfiguredProvider, Provider, ProviderFactory<UserProfileProvider>, UserProfileProvider, UserProfileProviderFactory<UserProfileProvider>

      public class DeclarativeUserProfileProvider
      extends AbstractUserProfileProvider<UserProfileProvider>
      implements AmphibianProviderFactory<UserProfileProvider>

  `UserProfileProvider` loading configuration from the changeable JSON file stored in component config. Parsed configuration is cached.
  Author:
    Pedro Igor, Vlastimil Elias

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static String` | `ID`
    `static String` | `REALM_USER_PROFILE_ENABLED`
    `static String` | `UP_PIECES_COUNT_COMPONENT_CONFIG_KEY`

    - ### Fields inherited from class org.keycloak.userprofile.AbstractUserProfileProvider

      `contextualMetadataRegistry, session`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `DeclarativeUserProfileProvider()`
    `DeclarativeUserProfileProvider(KeycloakSession session, Map<UserProfileContext,UserProfileMetadata> metadataRegistry, String defaultRawConfig)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected UserProfileMetadata` | `configureUserProfile(UserProfileMetadata metadata, KeycloakSession session)` Sub-types can override this method to customize how contextual profile metadata is configured at runtime.
    `protected UserProfileProvider` | `create(KeycloakSession session, Map<UserProfileContext,UserProfileMetadata> metadataRegistry)` Subclasses can override this method to create their instances of `UserProfileProvider`.
    `protected Attributes` | `createAttributes(UserProfileContext context, Map<String,?> attributes, UserModel user, UserProfileMetadata metadata)`
    `protected AttributeValidatorMetadata` | `createConfiguredValidator(String validator, Map<String,Object> validatorConfig)` Create validator for validation configured in the user profile config.
    `protected UserProfileMetadata` | `decorateUserProfileForCache(UserProfileMetadata decoratedMetadata, ComponentModel model)` Decorate basic metadata provided from `AbstractUserProfileProvider` based on 'per realm' configuration.
    `ComponentModel` | `getComponentModel()`
    `List<ProviderConfigProperty>` | `getConfigProperties()`
    `String` | `getConfiguration()` Get current UserProfile configuration.
    `String` | `getHelpText()`
    `String` | `getId()`
    `protected UPConfig` | `getParsedConfig(ComponentModel model)` Get parsed config file configured in model.
    `void` | `init(Config.Scope config)` Only called once when the factory is first created.
    `void` | `setConfiguration(String configuration)` Set new UserProfile configuration.
    `void` | `validateConfiguration(KeycloakSession session, RealmModel realm, ComponentModel model)` Called before a component is created or updated.

    - ### Methods inherited from class org.keycloak.userprofile.AbstractUserProfileProvider

      `close, configureUserProfile, create, create, create, create, getRegexPatternString, postInit`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.keycloak.component.AmphibianProviderFactory

      `close, create, create, onUpdate, preRemove`

    - ### Methods inherited from interface org.keycloak.component.ComponentFactory

      `getCommonProviderConfigProperties, getTypeMetadata, onCreate`

    - ### Methods inherited from interface org.keycloak.provider.ProviderFactory

      `order, postInit`

- - ### Field Detail

    - #### ID

          public static final String ID

      See Also:
        Constant Field Values

    - #### UP_PIECES_COUNT_COMPONENT_CONFIG_KEY

          public static final String UP_PIECES_COUNT_COMPONENT_CONFIG_KEY

      See Also:
        Constant Field Values

    - #### REALM_USER_PROFILE_ENABLED

          public static final String REALM_USER_PROFILE_ENABLED

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### DeclarativeUserProfileProvider

          public DeclarativeUserProfileProvider()

    - #### DeclarativeUserProfileProvider

          public DeclarativeUserProfileProvider(KeycloakSession session,
                                                Map<UserProfileContext,UserProfileMetadata> metadataRegistry,
                                                String defaultRawConfig)

  - ### Method Detail

    - #### getId

          public String getId()

      Specified by:
        `getId` in interface `ProviderFactory<UserProfileProvider>`

    - #### create

          protected UserProfileProvider create(KeycloakSession session,
                                               Map<UserProfileContext,UserProfileMetadata> metadataRegistry)

      Description copied from class: `AbstractUserProfileProvider`
      Subclasses can override this method to create their instances of `UserProfileProvider`.
      Specified by:
        `create` in class `AbstractUserProfileProvider<UserProfileProvider>`
      Parameters:
        `session` - the session
        `metadataRegistry` - the profile metadata
      Returns:
        the profile provider instance

    - #### createAttributes

          protected Attributes createAttributes(UserProfileContext context,
                                                Map<String,?> attributes,
                                                UserModel user,
                                                UserProfileMetadata metadata)

      Overrides:
        `createAttributes` in class `AbstractUserProfileProvider<UserProfileProvider>`

    - #### configureUserProfile

          protected UserProfileMetadata configureUserProfile(UserProfileMetadata metadata,
                                                             KeycloakSession session)

      Description copied from class: `AbstractUserProfileProvider`
      Sub-types can override this method to customize how contextual profile metadata is configured at runtime.
      Overrides:
        `configureUserProfile` in class `AbstractUserProfileProvider<UserProfileProvider>`
      Parameters:
        `metadata` - the profile metadata
        `session` - the current session
      Returns:
        the metadata

    - #### getHelpText

          public String getHelpText()

      Specified by:
        `getHelpText` in interface `ConfiguredProvider`

    - #### validateConfiguration

          public void validateConfiguration(KeycloakSession session,
                                            RealmModel realm,
                                            ComponentModel model)
                                     throws ComponentValidationException

      Description copied from interface: `ComponentFactory`
      Called before a component is created or updated. Allows you to validate the configuration
      Specified by:
        `validateConfiguration` in interface `ComponentFactory<UserProfileProvider,UserProfileProvider>`
      Throws:
        `ComponentValidationException`

    - #### getConfiguration

          public String getConfiguration()

      Description copied from interface: `UserProfileProvider`
      Get current UserProfile configuration. JSON formatted file is expected, but depends on the implementation.
      Specified by:
        `getConfiguration` in interface `UserProfileProvider`
      Overrides:
        `getConfiguration` in class `AbstractUserProfileProvider<UserProfileProvider>`
      Returns:
        current UserProfile configuration
      See Also:
        `UserProfileProvider.setConfiguration(String)`

    - #### setConfiguration

          public void setConfiguration(String configuration)

      Description copied from interface: `UserProfileProvider`
      Set new UserProfile configuration. It is persisted inside of the provider.
      Specified by:
        `setConfiguration` in interface `UserProfileProvider`
      Overrides:
        `setConfiguration` in class `AbstractUserProfileProvider<UserProfileProvider>`
      Parameters:
        `configuration` - to be set
      See Also:
        `UserProfileProvider.getConfiguration()`

    - #### getConfigProperties

          public List<ProviderConfigProperty> getConfigProperties()

      Specified by:
        `getConfigProperties` in interface `AmphibianProviderFactory<UserProfileProvider>`
      Specified by:
        `getConfigProperties` in interface `ConfiguredProvider`

    - #### init

          public void init(Config.Scope config)

      Description copied from interface: `ProviderFactory`
      Only called once when the factory is first created. This config is pulled from keycloak_server.json
      Specified by:
        `init` in interface `ProviderFactory<UserProfileProvider>`
      Overrides:
        `init` in class `AbstractUserProfileProvider<UserProfileProvider>`

    - #### getComponentModel

          public ComponentModel getComponentModel()

    - #### decorateUserProfileForCache

          protected UserProfileMetadata decorateUserProfileForCache(UserProfileMetadata decoratedMetadata,
                                                                    ComponentModel model)

      Decorate basic metadata provided from `AbstractUserProfileProvider` based on 'per realm' configuration. This method is called for each `UserProfileContext` in each realm, and metadata are cached then and this method is called again only if configuration changes.
      Parameters:
        `decoratedMetadata` - base to be decorated based on configuration loaded from component model
        `model` - component model to get "per realm" configuration from
      Returns:
        decorated metadata

    - #### getParsedConfig

          protected UPConfig getParsedConfig(ComponentModel model)

      Get parsed config file configured in model. Default one used if not configured.
      Parameters:
        `model` - to take config from
      Returns:
        parsed configuration

    - #### createConfiguredValidator

          protected AttributeValidatorMetadata createConfiguredValidator(String validator,
                                                                         Map<String,Object> validatorConfig)

      Create validator for validation configured in the user profile config.
      Parameters:
        `validator` - id to create validator for
        `validatorConfig` - of the validator
      Returns:
        validator metadata to run given validation

Copyright © 2021 JBoss by Red Hat. All rights reserved.